=== debian/changelog ===
deal.ii (9.5.1-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:52:06 +0000

deal.ii (9.5.1-2build2) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:21:08 +0000

deal.ii (9.5.1-2build1) noble; urgency=medium

  * Rebuild against latest gmsh

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 18 Feb 2024 15:30:51 -0500

deal.ii (9.5.1-2) unstable; urgency=medium

  [ Matthias Maier ]
  * Fix compilation with boost-1.83 on ppc64el,
    upstream: https://github.com/dealii/dealii/pull/16434
    (Closes: #1059349)

  [ Graham Inggs ]
  * Update debian/watch

 -- Matthias Maier <tamiko+DEBIAN@43-1.org>  Tue, 09 Jan 2024 13:32:19 +0000

deal.ii (9.5.1-1) unstable; urgency=medium

  * New upstream release
  * update patches
  * Disable dh_dwz

 -- Matthias Maier <tamiko+DEBIAN@43-1.org>  Fri, 15 Sep 2023 12:06:30 +0000
